"""
function: this code is used to organize TFBS and TFBS locations.
usage: python organize_tfbs.py <TFBS><TFBS location><Gene_name><lambda><out_fmt>
"""
# read in TFBS
import pdb,sys
f=open(sys.argv[1],'r')
lf=f.readlines()
f.close()
lf=[item.strip() for item in lf]
tfbs=lf

# read in TFBS location
f=open(sys.argv[2],'r')
lf=f.readlines()
f.close()
lf=[item.strip() for item in lf]
tfbs_loc=lf

# read in gene_name
f=open(sys.argv[3],'r')
lf=f.readlines()
f.close()
lf=[item.strip() for item in lf]
gene_name=lf

#read in lambda
f=open(sys.argv[4],'r')
lf=f.readlines()
f.close()
lf=[item.strip() for item in lf]
lf=[item.split('\t') for item in lf]
lam=lf

#
if sys.argv[5]=='txt':
	for i in range(len(tfbs)):
		tfbs[i]=tfbs[i].split(' ')
		#pdb.set_trace()
		for j in range(len(tfbs[i])):
			#pdb.set_trace()
			try:
				tfbs[i][j]=lam[int(tfbs[i][j])][0][1:]
			except:
				pass
		tfbs[i]=' '.join(tfbs[i])
		gene_name[i]=gene_name[i]+'\t'+tfbs[i]+'\t'+tfbs_loc[i]+'\n'
	gene_name='>sequence id'+'\t'+'TFBS'+'\t'+'TFBS_POSITION'+'\n'+''.join(gene_name)
	f=open(sys.argv[1]+'.txt','w')
	f.write(gene_name)
	f.close()

elif sys.argv[5]=='xls':
	for i in range(len(tfbs)):
		tfbs[i]=tfbs[i].split(' ')
		#pdb.set_trace()
		for j in range(len(tfbs[i])):
			#pdb.set_trace()
			try:
				tfbs[i][j]=lam[int(tfbs[i][j])][0][1:]
			except:
				pass
		tfbs[i]=' '.join(tfbs[i])
		gene_name[i]=gene_name[i]+'\t'+tfbs[i]+'\t'+tfbs_loc[i]+'\n'
	gene_name='>sequence id'+'\t'+'TFBS'+'\t'+'TFBS_POSITION'+'\n'+''.join(gene_name)
	f=open(sys.argv[1]+'.xls','w')
	f.write(gene_name)
	f.close()
